// la-deterministe-par-defaut.c

// << Algorithmique du texte >>
// Maxime Crochemore, Christophe Hancart et Thierry Lecroq
// Vuibert, 2001.

#include <stdio.h>
#include "chl.h"
#include "cellule.h"
#include "liste.h"
#include "ensemble.h"
#include "automate.h"
#include "cible-par-defaut.h"
#include "alp-par-defaut.h"


void laDeterministeParDefaut(Ensemble X, Mot y) {
   Automate M;
   Etat r;
   int j;

   M = alpParDefaut(X);
   r = initial(M);
   for (j = 0; *y != '\0'; ++j, ++y) {
      r = cibleParDefaut(M, r, *y);
      signalerSi(terminal(r));
   }
}
